include Math
require './laplas'
require './systgaus'
require './TkGrafiki'

class BalPV
	def initialize l,b,ej,c,m,v,p
		@l,@b,@ej,@c,@m,@v,@p = l,b,ej,c,m,v,p
	end
	def funkcii(x,s)
		a=((@m*s*s+@c*@b)/@ej)**(1/4.0); d=s/@v; al=a/sqrt(2)
		f1=sin(al*x)*sinh(al*x); f2=sin(al*x)*cosh(al*x)
		f3=cos(al*x)*sinh(al*x); f4=cos(al*x)*cosh(al*x)
		ex=exp(-d*x)

		f12=2*al**2*f4; f22=2*al**2*f3; f32=-2*al**2*f2; f42=-2*al**2*f1
		f13=2*al**3*(f3-f2); f23=2*al**3*(f4-f1)
		f33=-2*al**3*(f1+f4); f43=-2*al**3*(f3+f2)
		ex2=d*d*exp(-d*x); ex3=-d**3*exp(-d*x)
		{"a"=>a, "d"=>d, "al"=> al, "f1"=>f1, "f2"=>f2, "f3"=>f3,
		"f4"=>f4, "ex"=>ex, "f12"=>f12, "f22"=>f22, "f32"=>f32,
		"f42"=>f42, "f13"=>f13, "f23"=>f23, "f33"=>f33, "f43"=>f43,
		"ex2"=>ex2, "ex3"=>ex3}

	end
	def w0dw0(s)
	    rab=funkcii(@l,s)
		matr=[[rab["f42"], (rab["f22"]+rab["f32"])/(2*rab["al"])],
		[rab["f43"], (rab["f23"]+rab["f33"])/(2*rab["al"])]]

		b1=-@p/(@v*@ej*(rab["a"]**4+rab["d"]**4))*((-4*rab["al"]**3*rab["f42"]+
		(2*rab["al"]**2*rab["d"]-rab["d"]**3)*rab["f32"]+(2*rab["al"]**2*rab["d"]+
		rab["d"]**3)*rab["f22"]-2*rab["al"]*rab["d"]**2*rab["f12"])/
		(4*rab["al"]**3)+rab["ex2"])

		b2=-@p/(@v*@ej*(rab["a"]**4+rab["d"]**4))*((-4*rab["al"]**3*rab["f43"]+
		(2*rab["al"]**2*rab["d"]-rab["d"]**3)*rab["f33"]+(2*rab["al"]**2*rab["d"]+
		rab["d"]**3)*rab["f23"]-2*rab["al"]*rab["d"]**2*rab["f13"])/
		(4*rab["al"]**3)+rab["ex3"])
		 det=matr[0][0]*matr[1][1]-matr[0][1]*matr[1][0]
		 det1=b1*matr[1][1]-matr[0][1]*b2
		 det2=matr[0][0]*b2-b1*matr[1][0]
		 {"w0" => det1/det, "wd0" => det2/det }
	end
	def w(x,s)
		rab=funkcii(x,s)
		w0=w0dw0(s)
		@p/(@v*@ej*(rab["a"]**4+rab["d"]**4))*((-4*rab["al"]**3*rab["f4"]+
		(2*rab["al"]**2*rab["d"]-rab["d"]**3)*rab["f3"]+(2*rab["al"]**2*rab["d"]+
		rab["d"]**3)*rab["f2"]-2*rab["al"]*rab["d"]**2*rab["f1"])/
		(4*rab["al"]**3)+rab["ex"])+w0["w0"]*rab["f4"]+w0["wd0"]*
		(rab["f2"]+rab["f3"])/(2*rab["al"])
	end
	def m(x,s)
		rab=funkcii(x,s)
		w0=w0dw0(s)
		@p/(@v*(rab["a"]**4+rab["d"]**4))*((-4*rab["al"]**3*rab["f42"]+
		(2*rab["al"]**2*rab["d"]-rab["d"]**3)*rab["f32"]+(2*rab["al"]**2*rab["d"]+
		rab["d"]**3)*rab["f22"]-2*rab["al"]*rab["d"]**2*rab["f12"])/
		(4*rab["al"]**3)+rab["ex2"])+(w0["w0"]*rab["f42"]+w0["wd0"]*
		(rab["f22"]+rab["f32"])/(2*rab["al"]))*@ej
	end
	def r(x,s)
		rab=funkcii(x,s)
		w0=w0dw0(s)
		@p/(@v*(rab["a"]**4+rab["d"]**4))*((-4*rab["al"]**3*rab["f43"]+
		(2*rab["al"]**2*rab["d"]-rab["d"]**3)*rab["f33"]+(2*rab["al"]**2*rab["d"]+
		rab["d"]**3)*rab["f23"]-2*rab["al"]*rab["d"]**2*rab["f13"])/
		(4*rab["al"]**3)+rab["ex3"])+(w0["w0"]*rab["f43"]+w0["wd0"]*
		(rab["f23"]+rab["f33"])/(2*rab["al"]))*@ej
	end

end
l,b,ej,c,m,v,p=5.0,1.0,300000.0,100000.0,100.0,20.0,2000.0
rab = BalPV.new(l,b,ej,c,m,v,p)
#p rab.r(2.0,5.0)

nx,n,sigma=100,19,0.1
x=(0..nx).map {|i| i*l/nx };
t=(0..nx).map {|i| x[i]/v}
s=(0..n).map {|i| (2*i+1)*sigma}
w=[]
for i in (0..nx)
	fi=(0..n).map { |j| rab.w(x[i],s[j])}
	param={"t" => [t[i]], "fi" => fi, "si" => sigma} # random order
	w+=Laplas.new(param).obras
end

rab=(0..nx).map {|i| -w[i]}
graf x, rab

